<html>
<head>
<title>OgreD3D9RenderSystem.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_c7ffc14721c8bed1493f4f78ca8c7331.html">Direct3D9</a>      </li>
      <li class="navelem"><a class="el" href="dir_1208738e8444befc5f502320df40a1ea.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D9RenderSystem.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D9RenderSystem_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D9RENDERSYSTEM_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D9RENDERSYSTEM_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Prerequisites_8h.html">OgreD3D9Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringConverter_8h.html">OgreStringConverter.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystem_8h.html">OgreRenderSystem.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystemCapabilities_8h.html">OgreRenderSystemCapabilities.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Mappings_8h.html">OgreD3D9Mappings.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre 
<a name="l00039"></a>00039 {
<a name="l00040"></a><a class="code" href="OgreD3D9RenderSystem_8h.html#a737b417f16ea225cf15e8d4c23df53dc">00040</a> <span class="preprocessor">#define MAX_LIGHTS 8</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042     <span class="keyword">class </span>D3D9DriverList;
<a name="l00043"></a>00043     <span class="keyword">class </span>D3D9Driver;
<a name="l00044"></a>00044     <span class="keyword">class </span>D3D9Device;
<a name="l00045"></a>00045     <span class="keyword">class </span>D3D9DeviceManager;
<a name="l00046"></a>00046     <span class="keyword">class </span>D3D9ResourceManager;
<a name="l00047"></a>00047 
<a name="l00051"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html" title="Implementation of DirectX9 as a rendering system.">D3D9RenderSystem</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652f">00054</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652f">MultiheadUseType</a>
<a name="l00055"></a>00055         {
<a name="l00056"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652fa25921c72928c345bce879cdeb59ea4de">00056</a>             <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652fa25921c72928c345bce879cdeb59ea4de">mutAuto</a>,
<a name="l00057"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652faf9d4681736aed408d4446783840b775f">00057</a>             <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652faf9d4681736aed408d4446783840b775f">mutYes</a>,
<a name="l00058"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652fa0e39e4e40a49121c32929470d9829f38">00058</a>             mutNo
<a name="l00059"></a>00059         };
<a name="l00060"></a>00060         
<a name="l00061"></a>00061     <span class="keyword">private</span>:
<a name="l00063"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a9ad82a406dbfaf157ede21ab9d1e9f32">00063</a>         IDirect3D9*  <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a9ad82a406dbfaf157ede21ab9d1e9f32" title="Direct3D.">mD3D</a>;      
<a name="l00064"></a>00064         <span class="comment">// Stored options</span>
<a name="l00065"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#acb2ff44be3d94880008e788babaf5dee">00065</a>         <a class="code" href="group__General.html#gafba22dbf34cd07633293ddba65ee6add">ConfigOptionMap</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#acb2ff44be3d94880008e788babaf5dee">mOptions</a>;
<a name="l00066"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a36bd42d9f88d6e6857cc490a879e4895">00066</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a36bd42d9f88d6e6857cc490a879e4895">mFSAASamples</a>;
<a name="l00067"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a33560f49bfc72d7683115550641b6f62">00067</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a33560f49bfc72d7683115550641b6f62">mFSAAHint</a>;
<a name="l00068"></a>00068 
<a name="l00070"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac42565e63a42ad4379efaea0daf0aecb">00070</a>         HINSTANCE <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac42565e63a42ad4379efaea0daf0aecb" title="instance">mhInstance</a>;
<a name="l00071"></a>00071 
<a name="l00073"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a67fab17c21dace499da58b2f120d8b54">00073</a>         <a class="code" href="classOgre_1_1D3D9DriverList.html">D3D9DriverList</a>* <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a67fab17c21dace499da58b2f120d8b54" title="List of D3D drivers installed (video cards)">mDriverList</a>;
<a name="l00075"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ab9e4555721f8b24b647e625a1cec9f5e">00075</a>         <a class="code" href="classOgre_1_1D3D9Driver.html">D3D9Driver</a>* <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ab9e4555721f8b24b647e625a1cec9f5e" title="Currently active driver.">mActiveD3DDriver</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a51c46455862379eebea959c86d57994c">00077</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a51c46455862379eebea959c86d57994c" title="NVPerfHUD allowed?">mUseNVPerfHUD</a>;
<a name="l00079"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a77d328a1e873dce24877900e2042cbc7">00079</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a77d328a1e873dce24877900e2042cbc7" title="Per-stage constant support? (not in main caps since D3D specific &amp; minor)">mPerStageConstantSupport</a>;
<a name="l00081"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#acf11ddf6b3c03a0b1857bb667797d6c5">00081</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9RenderSystem.html" title="Implementation of DirectX9 as a rendering system.">D3D9RenderSystem</a>* <a class="code" href="classOgre_1_1D3D9RenderSystem.html#acf11ddf6b3c03a0b1857bb667797d6c5" title="Fast singleton access.">msD3D9RenderSystem</a>;
<a name="l00082"></a>00082 
<a name="l00084"></a><a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html">00084</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html" title="structure holding texture unit settings for every stage">sD3DTextureStageDesc</a>
<a name="l00085"></a>00085         {
<a name="l00087"></a><a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a04fcb76a11cde3a9c592fc021163c3ee">00087</a>             <a class="code" href="classOgre_1_1D3D9Mappings.html#a013e603712b5d552f59c4557c3bcff6f" title="enum identifying D3D9 tex. types">D3D9Mappings::eD3DTexType</a> <a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a04fcb76a11cde3a9c592fc021163c3ee" title="the type of the texture">texType</a>;
<a name="l00089"></a><a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a61a7972b660c1497dc6c9c6b0b8e8060">00089</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a61a7972b660c1497dc6c9c6b0b8e8060" title="which texCoordIndex to use">coordIndex</a>;
<a name="l00091"></a><a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a56f4463f0332ba653be960f0afff44b8">00091</a>             <a class="code" href="group__RenderSystem.html#gaa9c06899edc6b7aed7bf3b29abe9bb31" title="Enum describing the ways to generate texture coordinates.">TexCoordCalcMethod</a> <a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a56f4463f0332ba653be960f0afff44b8" title="type of auto tex. calc. used">autoTexCoordType</a>;
<a name="l00093"></a><a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a7d3850326cf1a52917bba20f8d592c88">00093</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a> *<a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a7d3850326cf1a52917bba20f8d592c88" title="Frustum, used if the above is projection.">frustum</a>;
<a name="l00095"></a><a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#aca49e2f37bea2bf0292fdd56c3b7fc8c">00095</a>             IDirect3DBaseTexture9 *<a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#aca49e2f37bea2bf0292fdd56c3b7fc8c" title="texture">pTex</a>;
<a name="l00097"></a><a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a444ce6ff42d453b743107f41ab7bb07a">00097</a>             IDirect3DBaseTexture9 *<a class="code" href="structOgre_1_1D3D9RenderSystem_1_1sD3DTextureStageDesc.html#a444ce6ff42d453b743107f41ab7bb07a" title="vertex texture">pVertexTex</a>;
<a name="l00098"></a>00098         } mTexStageDesc[<a class="code" href="OgreConfig_8h.html#a1c5fd80e6e0f2f85d6facbe1ec8eb5a4" title="Define max number of texture layers allowed per pass on any card.">OGRE_MAX_TEXTURE_LAYERS</a>];
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <span class="comment">// Array of up to 8 lights, indexed as per API</span>
<a name="l00101"></a>00101         <span class="comment">// Note that a null value indicates a free slot</span>
<a name="l00102"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a5aa19630bd04dc209a73d7730cf4ca45">00102</a>         <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* mLights[<a class="code" href="OgreD3D9RenderSystem_8h.html#a737b417f16ea225cf15e8d4c23df53dc">MAX_LIGHTS</a>];     
<a name="l00103"></a>00103         <a class="code" href="classOgre_1_1D3D9DriverList.html">D3D9DriverList</a>* getDirect3DDrivers();
<a name="l00104"></a>00104         <span class="keywordtype">void</span> refreshD3DSettings();
<a name="l00105"></a>00105         <span class="keywordtype">void</span> refreshFSAAOptions();
<a name="l00106"></a>00106         
<a name="l00107"></a>00107         <span class="keywordtype">void</span> setD3D9Light( <span class="keywordtype">size_t</span> index, <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light );
<a name="l00108"></a>00108         
<a name="l00109"></a>00109         <span class="comment">// state management methods, very primitive !!!</span>
<a name="l00110"></a>00110         HRESULT __SetRenderState(D3DRENDERSTATETYPE state, DWORD value);
<a name="l00111"></a>00111         HRESULT __SetSamplerState(DWORD sampler, D3DSAMPLERSTATETYPE type, DWORD value);
<a name="l00112"></a>00112         HRESULT __SetTextureStageState(DWORD stage, D3DTEXTURESTAGESTATETYPE type, DWORD value);
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac9e4ddcb5b8f3d6784fe255c69f9c2d9">00114</a>         HRESULT __SetFloatRenderState(D3DRENDERSTATETYPE state, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value)
<a name="l00115"></a>00115         {
<a name="l00116"></a>00116 <span class="preprocessor">#if OGRE_DOUBLE_PRECISION == 1</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>            <span class="keywordtype">float</span> temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>(value);
<a name="l00118"></a>00118             <span class="keywordflow">return</span> __SetRenderState(state, *((LPDWORD)(&amp;temp)));
<a name="l00119"></a>00119 <span class="preprocessor">#else</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>            <span class="keywordflow">return</span> __SetRenderState(state, *((LPDWORD)(&amp;value)));
<a name="l00121"></a>00121 <span class="preprocessor">#endif</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span>        }
<a name="l00123"></a>00123 
<a name="l00125"></a>00125         DWORD _getCurrentAnisotropy(<span class="keywordtype">size_t</span> unit);
<a name="l00127"></a>00127         <span class="keywordtype">bool</span> _checkMultiSampleQuality(D3DMULTISAMPLE_TYPE type, DWORD *outQuality, D3DFORMAT format, UINT adapterNum, D3DDEVTYPE deviceType, BOOL fullScreen);
<a name="l00128"></a>00128         
<a name="l00129"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#acd98ba94410bc322437599ed448e149b">00129</a>         <a class="code" href="classOgre_1_1D3D9HardwareBufferManager.html" title="D3D9HardwareBufferManagerBase as a Singleton.">D3D9HardwareBufferManager</a>* <a class="code" href="classOgre_1_1D3D9RenderSystem.html#acd98ba94410bc322437599ed448e149b">mHardwareBufferManager</a>;
<a name="l00130"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a69c3bbb24c0f8c33f20689deb5e1f0cc">00130</a>         <a class="code" href="classOgre_1_1D3D9GpuProgramManager.html">D3D9GpuProgramManager</a>* <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a69c3bbb24c0f8c33f20689deb5e1f0cc">mGpuProgramManager</a>;
<a name="l00131"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#aac5c028b034f31244840b22965cc5636">00131</a>         <a class="code" href="classOgre_1_1D3D9HLSLProgramFactory.html" title="Factory class for D3D9 HLSL programs.">D3D9HLSLProgramFactory</a>* <a class="code" href="classOgre_1_1D3D9RenderSystem.html#aac5c028b034f31244840b22965cc5636">mHLSLProgramFactory</a>;
<a name="l00132"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a9b1667d7c0d0931d3437cc7a7bdf890e">00132</a>         <a class="code" href="classOgre_1_1D3D9ResourceManager.html">D3D9ResourceManager</a>* <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a9b1667d7c0d0931d3437cc7a7bdf890e">mResourceManager</a>;
<a name="l00133"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a1d6b30a861ebd1066a8300464825e78f">00133</a>         <a class="code" href="classOgre_1_1D3D9DeviceManager.html" title="Device manager interface.">D3D9DeviceManager</a>* <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a1d6b30a861ebd1066a8300464825e78f">mDeviceManager</a>;
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ab6a744e5abfa7fe8224f120137aef593">00135</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ab6a744e5abfa7fe8224f120137aef593">mLastVertexSourceCount</a>;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00139"></a>00139         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* createRenderSystemCapabilities() <span class="keyword">const</span>;
<a name="l00140"></a>00140         <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* updateRenderSystemCapabilities(<a class="code" href="classOgre_1_1D3D9RenderWindow.html">D3D9RenderWindow</a>* renderWindow);
<a name="l00141"></a>00141 
<a name="l00143"></a>00143         <span class="keyword">virtual</span> <span class="keywordtype">void</span> initialiseFromRenderSystemCapabilities(<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* caps, <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>* primary);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146         <span class="keywordtype">void</span> convertVertexShaderCaps(<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* rsc) <span class="keyword">const</span>;
<a name="l00147"></a>00147         <span class="keywordtype">void</span> convertPixelShaderCaps(<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* rsc) <span class="keyword">const</span>;
<a name="l00148"></a>00148         <span class="keywordtype">bool</span> checkVertexTextureFormats(<a class="code" href="classOgre_1_1D3D9RenderWindow.html">D3D9RenderWindow</a>* renderWindow) <span class="keyword">const</span>;
<a name="l00149"></a>00149         
<a name="l00150"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a600ef822d88527e0dab77a7faf974310">00150</a>         HashMap&lt;IDirect3DDevice9*, unsigned short&gt; <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a600ef822d88527e0dab77a7faf974310">mCurrentLights</a>;
<a name="l00152"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a5148d217e957f58c33d874665a3569b2">00152</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a5148d217e957f58c33d874665a3569b2" title="Saved last view matrix.">mViewMatrix</a>;
<a name="l00153"></a>00153 
<a name="l00154"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#aab2b48310c543f2ff629026a3ab1986e">00154</a>         D3DXMATRIX mDxViewMat, mDxProjMat, <a class="code" href="classOgre_1_1D3D9RenderSystem.html#aab2b48310c543f2ff629026a3ab1986e">mDxWorldMat</a>;
<a name="l00155"></a>00155     
<a name="l00156"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#aa1cefcdee92b45785a5dccc47ba4a9b9">00156</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;D3D9RenderWindow*&gt;::type</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#aa1cefcdee92b45785a5dccc47ba4a9b9">D3D9RenderWindowList</a>;
<a name="l00157"></a>00157         <span class="comment">// List of additional windows after the first (swap chains)</span>
<a name="l00158"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a852038f2708c549f4c3905182e7c19a3">00158</a>         <a class="code" href="classOgre_1_1D3D9RenderSystem.html#aa1cefcdee92b45785a5dccc47ba4a9b9">D3D9RenderWindowList</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a852038f2708c549f4c3905182e7c19a3">mRenderWindows</a>;
<a name="l00159"></a>00159         
<a name="l00162"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#af93210d03368ef903fcb7fa90c63335c">00162</a>         <span class="keyword">typedef</span> HashMap&lt;unsigned int, D3DFORMAT&gt; <a class="code" href="classOgre_1_1D3D9RenderSystem.html#af93210d03368ef903fcb7fa90c63335c" title="Mapping of texture format -&gt; DepthStencil.">DepthStencilHash</a>;
<a name="l00163"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a362cbdb15a0333270ed2191fbfc97aa5">00163</a>         <a class="code" href="classOgre_1_1D3D9RenderSystem.html#af93210d03368ef903fcb7fa90c63335c" title="Mapping of texture format -&gt; DepthStencil.">DepthStencilHash</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a362cbdb15a0333270ed2191fbfc97aa5">mDepthStencilHash</a>;
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a33276d30323f1bbcff58a12d5fb1585e">00165</a>         <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652f">MultiheadUseType</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#a33276d30323f1bbcff58a12d5fb1585e">mMultiheadUse</a>;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167     <span class="keyword">protected</span>:
<a name="l00168"></a>00168         <span class="keywordtype">void</span> setClipPlanesImpl(<span class="keyword">const</span> <a class="code" href="group__Math.html#gae00d718daa48567f6c010aad9d6dd92c">PlaneList</a>&amp; clipPlanes);        
<a name="l00169"></a>00169     <span class="keyword">public</span>:
<a name="l00170"></a>00170         <span class="comment">// constructor</span>
<a name="l00171"></a>00171         <a class="code" href="classOgre_1_1D3D9RenderSystem.html" title="Implementation of DirectX9 as a rendering system.">D3D9RenderSystem</a>( HINSTANCE hInstance );
<a name="l00172"></a>00172         <span class="comment">// destructor</span>
<a name="l00173"></a>00173         ~<a class="code" href="classOgre_1_1D3D9RenderSystem.html" title="Implementation of DirectX9 as a rendering system.">D3D9RenderSystem</a>();
<a name="l00174"></a>00174 
<a name="l00175"></a>00175         <span class="keyword">virtual</span> <span class="keywordtype">void</span> initConfigOptions();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         <span class="comment">// Overridden RenderSystem functions</span>
<a name="l00178"></a>00178         <a class="code" href="group__General.html#gafba22dbf34cd07633293ddba65ee6add">ConfigOptionMap</a>&amp; getConfigOptions();
<a name="l00179"></a>00179         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfigOptions();
<a name="l00180"></a>00180         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* _initialise( <span class="keywordtype">bool</span> autoCreateWindow, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle = <span class="stringliteral">&quot;OGRE Render Window&quot;</span>  );
<a name="l00182"></a>00182         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* _createRenderWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00183"></a>00183             <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams = 0);
<a name="l00184"></a>00184         
<a name="l00186"></a>00186         <span class="keywordtype">bool</span> _createRenderWindows(<span class="keyword">const</span> <a class="code" href="group__General.html#ga7a03bf97326d0d0385b91a74e2c51c5e" title="Render window creation parameters container.">RenderWindowDescriptionList</a>&amp; renderWindowDescriptions, 
<a name="l00187"></a>00187             <a class="code" href="group__General.html#ga1d8e92efee48ea10e75189c8efa6ec51" title="Render window container.">RenderWindowList</a>&amp; createdWindows);
<a name="l00188"></a>00188 
<a name="l00190"></a>00190         <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>* _createDepthBufferFor( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *renderTarget );
<a name="l00191"></a>00191 
<a name="l00197"></a>00197         <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>* _addManualDepthBuffer( IDirect3DDevice9* depthSurfaceDevice, IDirect3DSurface9 *surf );
<a name="l00198"></a>00198 
<a name="l00208"></a>00208         <span class="keyword">using</span> <a class="code" href="classOgre_1_1RenderSystem.html#a568dd8e5d75fc7eef649dda6d14d447d" title="Removes all depth buffers.">RenderSystem::_cleanupDepthBuffers</a>;
<a name="l00209"></a>00209         <span class="keywordtype">void</span> _cleanupDepthBuffers( IDirect3DDevice9 *creator );
<a name="l00210"></a>00210 
<a name="l00218"></a>00218         <span class="keywordtype">void</span> _cleanupDepthBuffers( IDirect3DSurface9 *manualSurface );
<a name="l00219"></a>00219 
<a name="l00223"></a>00223         <span class="keywordtype">void</span> _setRenderTarget(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target);
<a name="l00224"></a>00224         
<a name="l00226"></a>00226         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a> * createMultiRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name);
<a name="l00227"></a>00227 
<a name="l00228"></a>00228         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getErrorDescription( <span class="keywordtype">long</span> errorNumber ) <span class="keyword">const</span>;
<a name="l00229"></a>00229         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName() <span class="keyword">const</span>;
<a name="l00230"></a>00230         <span class="comment">// Low-level overridden members</span>
<a name="l00231"></a>00231         <span class="keywordtype">void</span> setConfigOption( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value );
<a name="l00232"></a>00232         <span class="keywordtype">void</span> reinitialise();
<a name="l00233"></a>00233         <span class="keywordtype">void</span> shutdown();
<a name="l00234"></a>00234         <span class="keywordtype">void</span> setAmbientLight( <span class="keywordtype">float</span> r, <span class="keywordtype">float</span> g, <span class="keywordtype">float</span> b );
<a name="l00235"></a>00235         <span class="keywordtype">void</span> setShadingType( <a class="code" href="group__General.html#ga7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> so );
<a name="l00236"></a>00236         <span class="keywordtype">void</span> setLightingEnabled( <span class="keywordtype">bool</span> enabled );
<a name="l00237"></a>00237         <span class="keywordtype">void</span> destroyRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00238"></a>00238         <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> getColourVertexElementType() <span class="keyword">const</span>;
<a name="l00239"></a>00239         <span class="keywordtype">void</span> setStencilCheckEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00240"></a>00240         <span class="keywordtype">void</span> setStencilBufferParams(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aae10ea1648cd8c9bd90bdaccaa11cbc4e">CMPF_ALWAYS_PASS</a>, 
<a name="l00241"></a>00241             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> refValue = 0, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask = 0xFFFFFFFF, 
<a name="l00242"></a>00242             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> stencilFailOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>, 
<a name="l00243"></a>00243             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> depthFailOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l00244"></a>00244             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> passOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>, 
<a name="l00245"></a>00245             <span class="keywordtype">bool</span> twoSidedOperation = <span class="keyword">false</span>);
<a name="l00246"></a>00246         <span class="keywordtype">void</span> setNormaliseNormals(<span class="keywordtype">bool</span> normalise);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248         <span class="comment">// Low-level overridden members, mainly for internal use</span>
<a name="l00249"></a>00249         <span class="keywordtype">void</span> _useLights(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; lights, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> limit);
<a name="l00250"></a>00250         <span class="keywordtype">void</span> _setWorldMatrix( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m );
<a name="l00251"></a>00251         <span class="keywordtype">void</span> _setViewMatrix( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m );
<a name="l00252"></a>00252         <span class="keywordtype">void</span> _setProjectionMatrix( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m );
<a name="l00253"></a>00253         <span class="keywordtype">void</span> _setSurfaceParams( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;ambient, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;diffuse, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;specular, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;emissive, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> shininess, <a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a> tracking );
<a name="l00254"></a>00254         <span class="keywordtype">void</span> _setPointSpritesEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00255"></a>00255         <span class="keywordtype">void</span> _setPointParameters(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> size, <span class="keywordtype">bool</span> attenuationEnabled, 
<a name="l00256"></a>00256             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> constant, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linear, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> quadratic, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> minSize, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> maxSize);
<a name="l00257"></a>00257         <span class="keywordtype">void</span> _setTexture(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">bool</span> enabled, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> &amp;texPtr);
<a name="l00258"></a>00258         <span class="keywordtype">void</span> _setVertexTexture(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; tex);
<a name="l00259"></a>00259         <span class="keywordtype">void</span> _disableTextureUnit(<span class="keywordtype">size_t</span> texUnit);
<a name="l00260"></a>00260         <span class="keywordtype">void</span> _setTextureCoordSet( <span class="keywordtype">size_t</span> unit, <span class="keywordtype">size_t</span> index );
<a name="l00261"></a>00261         <span class="keywordtype">void</span> _setTextureCoordCalculation(<span class="keywordtype">size_t</span> unit, <a class="code" href="group__RenderSystem.html#gaa9c06899edc6b7aed7bf3b29abe9bb31" title="Enum describing the ways to generate texture coordinates.">TexCoordCalcMethod</a> m, 
<a name="l00262"></a>00262             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>* frustum = 0);
<a name="l00263"></a>00263         <span class="keywordtype">void</span> _setTextureBlendMode( <span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a>&amp; bm );
<a name="l00264"></a>00264         <span class="keywordtype">void</span> _setTextureAddressingMode(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html" title="Texture addressing mode for each texture coordinate.">TextureUnitState::UVWAddressingMode</a>&amp; uvw);
<a name="l00265"></a>00265         <span class="keywordtype">void</span> _setTextureBorderColour(<span class="keywordtype">size_t</span> stage, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour);
<a name="l00266"></a>00266         <span class="keywordtype">void</span> _setTextureMipmapBias(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">float</span> bias);
<a name="l00267"></a>00267         <span class="keywordtype">void</span> _setTextureMatrix( <span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;xform );
<a name="l00268"></a>00268         <span class="keywordtype">void</span> _setSceneBlending( <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op );
<a name="l00269"></a>00269         <span class="keywordtype">void</span> _setSeparateSceneBlending( <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactorAlpha, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactorAlpha, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> alphaOp );
<a name="l00270"></a>00270         <span class="keywordtype">void</span> _setAlphaRejectSettings( <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> value, <span class="keywordtype">bool</span> alphaToCoverage );
<a name="l00271"></a>00271         <span class="keywordtype">void</span> _setViewport( <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp );      
<a name="l00272"></a>00272         <span class="keywordtype">void</span> _beginFrame();
<a name="l00273"></a>00273         <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1RenderSystem_1_1RenderSystemContext.html">RenderSystemContext</a>* _pauseFrame(<span class="keywordtype">void</span>);
<a name="l00274"></a>00274         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _resumeFrame(<a class="code" href="structOgre_1_1RenderSystem_1_1RenderSystemContext.html">RenderSystemContext</a>* context);
<a name="l00275"></a>00275         <span class="keywordtype">void</span> _endFrame();       
<a name="l00276"></a>00276         <span class="keywordtype">void</span> _setCullingMode( <a class="code" href="group__General.html#gac173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mode );
<a name="l00277"></a>00277         <span class="keywordtype">void</span> _setDepthBufferParams( <span class="keywordtype">bool</span> depthTest = <span class="keyword">true</span>, <span class="keywordtype">bool</span> depthWrite = <span class="keyword">true</span>, <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> depthFunction = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aa2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a> );
<a name="l00278"></a>00278         <span class="keywordtype">void</span> _setDepthBufferCheckEnabled( <span class="keywordtype">bool</span> enabled = <span class="keyword">true</span> );
<a name="l00279"></a>00279         <span class="keywordtype">void</span> _setColourBufferWriteEnabled(<span class="keywordtype">bool</span> red, <span class="keywordtype">bool</span> green, <span class="keywordtype">bool</span> blue, <span class="keywordtype">bool</span> alpha);
<a name="l00280"></a>00280         <span class="keywordtype">void</span> _setDepthBufferWriteEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>);
<a name="l00281"></a>00281         <span class="keywordtype">void</span> _setDepthBufferFunction( <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aa2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a> );
<a name="l00282"></a>00282         <span class="keywordtype">void</span> _setDepthBias(<span class="keywordtype">float</span> constantBias, <span class="keywordtype">float</span> slopeScaleBias);
<a name="l00283"></a>00283         <span class="keywordtype">void</span> _setFog( <a class="code" href="group__General.html#ga83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mode = <a class="code" href="group__General.html#gga83edeb2e5d33a3ca8f15834ba40020baab7793a21880052c0214d4cc040992310" title="No fog. Duh.">FOG_NONE</a>, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> expDensity = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearStart = 0.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearEnd = 1.0 );
<a name="l00284"></a>00284         <span class="keywordtype">void</span> _convertProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix,
<a name="l00285"></a>00285             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00286"></a>00286         <span class="keywordtype">void</span> _makeProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, 
<a name="l00287"></a>00287             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00288"></a>00288         <span class="keywordtype">void</span> _makeProjectionMatrix(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, 
<a name="l00289"></a>00289             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00290"></a>00290         <span class="keywordtype">void</span> _makeOrthoMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, 
<a name="l00291"></a>00291             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>);
<a name="l00292"></a>00292         <span class="keywordtype">void</span> _applyObliqueDepthProjection(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane, 
<a name="l00293"></a>00293             <span class="keywordtype">bool</span> forGpuProgram);
<a name="l00294"></a>00294         <span class="keywordtype">void</span> _setPolygonMode(<a class="code" href="group__General.html#ga68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> level);
<a name="l00295"></a>00295         <span class="keywordtype">void</span> _setTextureUnitFiltering(<span class="keywordtype">size_t</span> unit, <a class="code" href="group__General.html#gac1fc36ec2f4df4b2afa9fa39f9c66c06">FilterType</a> ftype, <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> filter);
<a name="l00296"></a>00296         <span class="keywordtype">void</span> _setTextureLayerAnisotropy(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxAnisotropy);
<a name="l00297"></a>00297         <span class="keywordtype">void</span> setVertexDeclaration(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl);
<a name="l00298"></a>00298         <span class="keywordtype">void</span> setVertexDeclaration(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl, <span class="keywordtype">bool</span> useGlobalInstancingVertexBufferIsAvailable);
<a name="l00299"></a>00299         <span class="keywordtype">void</span> setVertexBufferBinding(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding);
<a name="l00300"></a>00300         <span class="keywordtype">void</span> setVertexBufferBinding(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding, <span class="keywordtype">size_t</span> numberOfInstances, <span class="keywordtype">bool</span> useGlobalInstancingVertexBufferIsAvailable, <span class="keywordtype">bool</span> indexesUsed);
<a name="l00301"></a>00301         <span class="keywordtype">void</span> _render(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00305"></a>00305         <span class="keywordtype">void</span> bindGpuProgram(<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* prg);
<a name="l00309"></a>00309         <span class="keywordtype">void</span> unbindGpuProgram(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l00313"></a>00313         <span class="keywordtype">void</span> bindGpuProgramParameters(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, 
<a name="l00314"></a>00314             <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> variabilityMask);
<a name="l00315"></a>00315         <span class="keywordtype">void</span> bindGpuProgramPassIterationParameters(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l00316"></a>00316 
<a name="l00317"></a>00317         <span class="keywordtype">void</span> setScissorTest(<span class="keywordtype">bool</span> enabled, <span class="keywordtype">size_t</span> left = 0, <span class="keywordtype">size_t</span> top = 0, <span class="keywordtype">size_t</span> right = 800, <span class="keywordtype">size_t</span> bottom = 600);
<a name="l00318"></a>00318         <span class="keywordtype">void</span> clearFrameBuffer(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffers, 
<a name="l00319"></a>00319             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a7f8a06f2a9dd645417c36b560f496c1a">ColourValue::Black</a>, 
<a name="l00320"></a>00320             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> depth = 1.0f, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> stencil = 0);
<a name="l00321"></a>00321         <span class="keywordtype">void</span> setClipPlane (<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> A, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> B, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> C, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> D);
<a name="l00322"></a>00322         <span class="keywordtype">void</span> enableClipPlane (<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index, <span class="keywordtype">bool</span> enable);
<a name="l00323"></a>00323         <a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for hardware occlusion...">HardwareOcclusionQuery</a>* createHardwareOcclusionQuery();
<a name="l00324"></a>00324         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getHorizontalTexelOffset();
<a name="l00325"></a>00325         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getVerticalTexelOffset();
<a name="l00326"></a>00326         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMinimumDepthInputValue();
<a name="l00327"></a>00327         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMaximumDepthInputValue();
<a name="l00328"></a>00328         <span class="keywordtype">void</span> registerThread();
<a name="l00329"></a>00329         <span class="keywordtype">void</span> unregisterThread();
<a name="l00330"></a>00330         <span class="keywordtype">void</span> preExtraThreadsStarted();
<a name="l00331"></a>00331         <span class="keywordtype">void</span> postExtraThreadsStarted();     
<a name="l00332"></a>00332         
<a name="l00333"></a>00333         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9ResourceManager.html">D3D9ResourceManager</a>* getResourceManager();
<a name="l00334"></a>00334         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9DeviceManager.html" title="Device manager interface.">D3D9DeviceManager</a>* getDeviceManager();
<a name="l00335"></a>00335         <span class="keyword">static</span> IDirect3D9* getDirect3D9();
<a name="l00336"></a>00336         <span class="keyword">static</span> UINT getResourceCreationDeviceCount();
<a name="l00337"></a>00337         <span class="keyword">static</span> IDirect3DDevice9* getResourceCreationDevice(UINT index);
<a name="l00338"></a>00338         <span class="keyword">static</span> IDirect3DDevice9* getActiveD3D9Device();
<a name="l00339"></a>00339 
<a name="l00343"></a>00343         D3DFORMAT _getDepthStencilFormatFor(D3DFORMAT fmt);
<a name="l00344"></a>00344 
<a name="l00348"></a>00348         <span class="keywordtype">bool</span> _checkTextureFilteringSupported(<a class="code" href="group__Resources.html#gae50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> ttype, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format, <span class="keywordtype">int</span> usage);
<a name="l00349"></a>00349 
<a name="l00351"></a>00351         <span class="keywordtype">void</span> determineFSAASettings(IDirect3DDevice9* d3d9Device, <span class="keywordtype">size_t</span> fsaa, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; fsaaHint, D3DFORMAT d3dPixelFormat, 
<a name="l00352"></a>00352             <span class="keywordtype">bool</span> fullScreen, D3DMULTISAMPLE_TYPE *outMultisampleType, DWORD *outMultisampleQuality);
<a name="l00353"></a>00353 
<a name="l00355"></a>00355         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getDisplayMonitorCount() <span class="keyword">const</span>;
<a name="l00356"></a>00356         
<a name="l00358"></a>00358         <span class="keywordtype">void</span> fireDeviceEvent( <a class="code" href="classOgre_1_1D3D9Device.html" title="High level interface of Direct3D9 Device.">D3D9Device</a>* device, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name );
<a name="l00359"></a>00359 
<a name="l00361"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac8accb2fe972b2568f17371a2abf94ac">00361</a>         <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac150cea205fda65dacbccaee1d5d652f">MultiheadUseType</a> <a class="code" href="classOgre_1_1D3D9RenderSystem.html#ac8accb2fe972b2568f17371a2abf94ac" title="Returns how multihead should be activated.">getMultiheadUse</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMultiheadUse; }
<a name="l00362"></a>00362     <span class="keyword">protected</span>:  
<a name="l00364"></a>00364         DWORD getSamplerId(<span class="keywordtype">size_t</span> unit);
<a name="l00365"></a>00365 
<a name="l00367"></a>00367         <span class="keywordtype">void</span> notifyOnDeviceLost(<a class="code" href="classOgre_1_1D3D9Device.html" title="High level interface of Direct3D9 Device.">D3D9Device</a>* device);
<a name="l00368"></a>00368 
<a name="l00370"></a>00370         <span class="keywordtype">void</span> notifyOnDeviceReset(<a class="code" href="classOgre_1_1D3D9Device.html" title="High level interface of Direct3D9 Device.">D3D9Device</a>* device);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372     <span class="keyword">private</span>:
<a name="l00373"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#a62a49b9f66b36b9be215f88e190366a2">00373</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9Device.html" title="High level interface of Direct3D9 Device.">D3D9Device</a>;
<a name="l00374"></a><a class="code" href="classOgre_1_1D3D9RenderSystem.html#aec82c6ec0be39f7ecb3e0d165125a540">00374</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9DeviceManager.html" title="Device manager interface.">D3D9DeviceManager</a>;     
<a name="l00375"></a>00375     };
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
